﻿Type=Activity
Version=3.8
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: True
#End Region

'Activity module
Sub Process_Globals
	Dim AStream As AsyncStreams

End Sub

Sub Globals
	Dim inviato As String
	Dim txtInput As EditText
	Dim txtLog As EditText
	Dim btnSend As Button
	
Dim Feed As CustomYouTubeFeed

Dim TotalVideos As Label
Dim WebView1 As WebView
Dim MoreButton As Button

Dim RecordsCounter As Int	'Counter to display the total number of videos/entries
Dim fIndex As Int				
Dim fMaxResults As Int
				
	Private Button2 As Button
		
	Private Button1 As Button
	Private EditText1 As EditText
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("2")
	Activity.Title="YT Master"
	If AStream.IsInitialized = False Then
		AStream.InitializePrefix(Main.serial1.InputStream, True, Main.serial1.OutputStream, "AStream")
	End If
	txtLog.Width = 100%x
	
				RecordsCounter = 0
				fIndex = 1 'We start getting results from index 1
				fMaxResults = 50 'How many results we retrieve at a time (max 50)
				
				Feed.Initialize(WebView1, "", "")

   
	
End Sub
Sub Activity_KeyPress (KeyCode As Int) As Boolean 'return true if you want to consume the event
   
	
	If KeyCode = KeyCodes.KEYCODE_BACK  Then
	    

			Return True
		
			
		

	End If	
	    
End Sub
Sub AStream_NewData (Buffer() As Byte)
	LogMessage("You", BytesToString(Buffer, 0, Buffer.Length, "UTF8"))
End Sub

Sub AStream_Error
	ToastMessageShow("Connection is broken.", True)
	btnSend.Enabled = False
	txtInput.Enabled = False
End Sub

Sub AStream_Terminated
	AStream_Error
End Sub

Sub Activity_Resume
	
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		AStream.Close
	End If
End Sub

Sub txtInput_EnterPressed
	If btnSend.Enabled = True Then btnSend_Click
End Sub
Sub btnSend_Click
	AStream.Write(txtInput.Text.GetBytes("UTF8"))
	txtInput.SelectAll
	txtInput.RequestFocus
	LogMessage("Me", txtInput.Text)
End Sub

Sub LogMessage(From As String, Msg As String)
	txtLog.Text = txtLog.Text & From & ": " & Msg & CRLF
	txtLog.SelectionStart = txtLog.Text.Length
End Sub
Sub Button1_Click
CallSubDelayed(Main,"CloseAll")
End Sub
Sub WebView1_PageFinished(Url As String)

    ProgressDialogHide

    'Make everything visible again
				TotalVideos.Visible = True
				WebView1.Visible = True
				MoreButton.Visible = True
			 
				If fMaxResults = Feed.Results	Then	'If the number of videos matches, continue
				
				   fIndex = fIndex + Feed.Results + 1
										
				Else 'All entries have been retrieved, make the button invisible and resize the WebView to make it look nice

							WebView1.Height = 100%y - TotalVideos.Height
					  MoreButton.Visible = False
										
    End If

	   RecordsCounter = RecordsCounter + Feed.Results 'Update number of videos
				
				TotalVideos.Text = "  Loaded videos: " & RecordsCounter 'Update the label
	
End Sub

Sub WebView1_OverrideUrl(Url As String) As Boolean   			
Dim temp As String
Dim r As Int
r=0
temp=""
temp=Url
r=temp.IndexOf("v")
temp=temp.SubString(r+2)
r=temp.IndexOf("&")

If r>0 Then 

	temp=temp.SubString2(0,r)
	
		If inviato <> temp Then
			inviato=temp
			AStream.Write(temp.GetBytes("UTF8"))
				WebView1.LoadUrl("") 'Clear WebView to properly display the pagination

				Else
		End If
End If

End Sub
Sub MoreButton_Click
hidekeyboard
Dim o As Reflector
o.Target = WebView1
o.RunMethod2("clearCache","true","java.lang.boolean")

	WebView1.LoadUrl("") 'Clear WebView to properly display the pagination
				
    'Make everything invisible to prevent the user tapping on the webview or button during the update
				TotalVideos.Visible = False
				WebView1.Visible = False
				MoreButton.Visible = False				
	
	   ProgressDialogShow("Loading...")			
						Feed.Initialize(WebView1, "", "")

					Feed.SearchVideos(EditText1.text, fIndex, fMaxResults)
	
				'Feed.GetUserUploads("bumpskey", fIndex, fMaxResults)
				'Feed.GetRelatedVideos("HzFEK0fbZ8U", fIndex, fMaxResults)
End Sub
Sub Button2_Click
EditText1.text=""	
EditText1.RequestFocus
End Sub
Sub hidekeyboard
Dim ph1 As Phone
ph1.hidekeyboard(Activity)
End Sub